diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java b/base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java
index 1d7f8aeae2630b234625d7d08987d07792c89a5e..da1c786611df95aecf0af498abbaf44c43f62498 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java
+++ b/base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java
@@ -17,27 +17,31 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.request.model;
 
-import java.math.BigInteger;
 import java.util.ArrayList;
 import java.util.Collection;
+import java.util.HashMap;
 import java.util.List;
+import java.util.Locale;
+import java.util.Random;
 
-import javax.ws.rs.Path;
-import javax.ws.rs.core.UriBuilder;
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServletRequest;
 import javax.ws.rs.core.UriInfo;
 
-import netscape.security.x509.X509CertImpl;
-
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
+import com.netscape.certsrv.base.Nonces;
 import com.netscape.certsrv.ca.ICertificateAuthority;
-import com.netscape.certsrv.profile.IEnrollProfile;
+import com.netscape.certsrv.profile.IProfile;
+import com.netscape.certsrv.profile.IProfileSubsystem;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.IRequestQueue;
 import com.netscape.certsrv.request.RequestId;
-import com.netscape.certsrv.request.RequestStatus;
-import com.netscape.cms.servlet.cert.CertResource;
-import com.netscape.cms.servlet.request.CertRequestResource;
+import com.netscape.cms.servlet.cert.EnrollmentProcessor;
+import com.netscape.cms.servlet.cert.RenewalProcessor;
+import com.netscape.cms.servlet.cert.RequestProcessor;
+import com.netscape.cms.servlet.processors.Processor;
+import com.netscape.cms.servlet.request.RequestNotFoundException;
 
 /**
  * @author alee
@@ -46,16 +50,22 @@ import com.netscape.cms.servlet.request.CertRequestResource;
 public class CertRequestDAO extends CMSRequestDAO {
     private IRequestQueue queue;
     private ICertificateAuthority ca;
+    IProfileSubsystem ps;
+    private Nonces nonces = null;
+    private Random random = null;
 
     public static final String ATTR_SERIALNO = "serialNumber";
-    private static final String REQ_COMPLETE = "complete";
+    public static final String REQ_COMPLETE = "complete";
 
     public CertRequestDAO() {
-
         super("ca");
         ca = (ICertificateAuthority) CMS.getSubsystem("ca");
         queue = ca.getRequestQueue();
-
+        if (ca.noncesEnabled()) {
+            random = new Random();
+            nonces = ca.getNonces();
+        }
+        ps = (IProfileSubsystem) CMS.getSubsystem(IProfileSubsystem.ID);
     }
 
     /**
@@ -122,86 +132,87 @@ public class CertRequestDAO extends CMSRequestDAO {
     }
 
     /**
+     * Gets info for a specific request
+     *
+     * @param id
+     * @return info for specific request
+     * @throws EBaseException
+     */
+    public AgentEnrollmentRequestData reviewRequest(HttpServletRequest servletRequest, RequestId id,
+            UriInfo uriInfo, Locale locale) throws EBaseException {
+        IRequest request = queue.findRequest(id);
+        if (request == null) {
+            return null;
+        }
+        String profileId = request.getExtDataInString("profileId");
+        IProfile profile = ps.getProfile(profileId);
+
+        AgentEnrollmentRequestData info = AgentEnrollmentRequestDataFactory.create(request, profile, uriInfo, locale);
+        if (ca.noncesEnabled()) {
+            addNonce(info, servletRequest);
+        }
+        return info;
+    }
+
+
+    private void addNonce(AgentEnrollmentRequestData info, HttpServletRequest servletRequest) throws EBaseException {
+        if (nonces != null) {
+            long n = random.nextLong();
+            long m = nonces.addNonce(n, Processor.getSSLClientCertificate(servletRequest));
+            if ((n + m) != 0) {
+                info.setNonce(Long.toString(m));
+            }
+        }
+    }
+
+    /**
      * Submits an enrollment request and processes it.
      *
      * @param data
      * @return info for the request submitted.
      * @throws EBaseException
+     * @throws ServletException
      */
-    public CertRequestInfo submitRequest(EnrollmentRequestData data, UriInfo uriInfo) throws EBaseException {
-
-        //TODO perform actual profile request.
-
-        throw new EBaseException("Not implemented.");
-    }
-
-    public void approveRequest(RequestId id) throws EBaseException {
-        IRequest request = queue.findRequest(id);
-        request.setRequestStatus(RequestStatus.APPROVED);
-        queue.updateRequest(request);
-    }
-
-    public void rejectRequest(RequestId id) throws EBaseException {
-        IRequest request = queue.findRequest(id);
-        request.setRequestStatus(RequestStatus.CANCELED);
-        queue.updateRequest(request);
-    }
-
-    public void cancelRequest(RequestId id) throws EBaseException {
-        IRequest request = queue.findRequest(id);
-        request.setRequestStatus(RequestStatus.REJECTED);
-        queue.updateRequest(request);
-    }
-
-    private CertRequestInfo createCertRequestInfo(IRequest request, UriInfo uriInfo) {
-        CertRequestInfo ret = new CertRequestInfo();
-
-        String requestType = request.getRequestType();
-        String requestStatus = request.getRequestStatus().toString();
-
-        ret.setRequestType(requestType);
-        ret.setRequestStatus(requestStatus);
-
-        ret.setCertRequestType(request.getExtDataInString("cert_request_type"));
-
-        Path certRequestPath = CertRequestResource.class.getAnnotation(Path.class);
-        RequestId rid = request.getRequestId();
-
-        UriBuilder reqBuilder = uriInfo.getBaseUriBuilder();
-        reqBuilder.path(certRequestPath.value() + "/" + rid);
-        ret.setRequestURL(reqBuilder.build().toString());
-
-        //Get Cert info if issued.
-
-        String serialNoStr = null;
-
-        if ((requestType != null) && (requestStatus != null)) {
-            if (requestStatus.equals(REQ_COMPLETE)) {
-                X509CertImpl impl[] = new X509CertImpl[1];
-                impl[0] = request.getExtDataInCert(IEnrollProfile.REQUEST_ISSUED_CERT);
-
-                BigInteger serialNo;
-                if (impl[0] != null) {
-                    serialNo = impl[0].getSerialNumber();
-                    serialNoStr = serialNo.toString();
-                }
-            }
-
+    public CertRequestInfos submitRequest(EnrollmentRequestData data, HttpServletRequest request, UriInfo uriInfo,
+            Locale locale) throws EBaseException {
+        HashMap<String, Object> results = null;
+        if (data.getIsRenewal()) {
+            RenewalProcessor processor = new RenewalProcessor("caProfileSubmit", locale);
+            results = processor.processRenewal(data, request);
+        } else {
+            EnrollmentProcessor processor = new EnrollmentProcessor("caProfileSubmit", locale);
+            results = processor.processEnrollment(data, request);
         }
 
-        if (serialNoStr != null && !serialNoStr.equals("")) {
-            Path certPath = CertResource.class.getAnnotation(Path.class);
-            UriBuilder certBuilder = uriInfo.getBaseUriBuilder();
-            certBuilder.path(certPath.value() + "/" + serialNoStr);
-            ret.setCertURL(certBuilder.build().toString());
+        CertRequestInfos ret = new CertRequestInfos();
+        ArrayList<CertRequestInfo> infos = new ArrayList<CertRequestInfo>();
+        IRequest reqs[] = (IRequest[]) results.get(Processor.ARG_REQUESTS);
+        for (IRequest req : reqs) {
+            CertRequestInfo info = CertRequestInfoFactory.create(req, uriInfo);
+            infos.add(info);
         }
+        // TODO - what happens if the errorCode is internal error ?
+        ret.setRequests(infos);
+        ret.setLinks(null);
 
         return ret;
     }
 
+    public void changeRequestState(RequestId id, HttpServletRequest request, AgentEnrollmentRequestData data,
+            Locale locale, String op) throws EBaseException {
+        IRequest ireq = queue.findRequest(id);
+        if (ireq == null) {
+            throw new RequestNotFoundException(id);
+        }
+
+        RequestProcessor processor = new RequestProcessor("caProfileProcess", locale);
+        processor.processRequest(request, data, ireq, op);
+    }
+
+
     @Override
     public CertRequestInfo createCMSRequestInfo(IRequest request, UriInfo uriInfo) {
-        return createCertRequestInfo(request, uriInfo);
+        return CertRequestInfoFactory.create(request, uriInfo);
     }
 
 }
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfo.java b/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfo.java
index 25083126d58cd876132bc479308597dd9ae444c1..20c298136b37749c85fe9ed224d262328d641ff0 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfo.java
+++ b/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfo.java
@@ -74,6 +74,7 @@ public class CertRequestInfo extends CMSRequestInfo {
      */
 
     public CertId getCertId() {
+        if (certURL == null) return null;
         String id = certURL.substring(certURL.lastIndexOf("/") + 1);
         return new CertId(id);
     }
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java b/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java
new file mode 100644
index 0000000000000000000000000000000000000000..7045f3366e6fef0b7807d9df1957a5e817dc6844
--- /dev/null
+++ b/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java
@@ -0,0 +1,81 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
+package com.netscape.cms.servlet.request.model;
+
+import java.math.BigInteger;
+
+import javax.ws.rs.Path;
+import javax.ws.rs.core.UriBuilder;
+import javax.ws.rs.core.UriInfo;
+
+import netscape.security.x509.X509CertImpl;
+
+import com.netscape.certsrv.profile.IEnrollProfile;
+import com.netscape.certsrv.request.IRequest;
+import com.netscape.certsrv.request.RequestId;
+import com.netscape.cms.servlet.cert.CertResource;
+import com.netscape.cms.servlet.request.CertRequestResource;
+
+public class CertRequestInfoFactory {
+
+    public static final String REQ_COMPLETE = "complete";
+
+    public static CertRequestInfo create(IRequest request, UriInfo uriInfo) {
+        CertRequestInfo ret = new CertRequestInfo();
+        String requestType = request.getRequestType();
+        String requestStatus = request.getRequestStatus().toString();
+
+        ret.setRequestType(requestType);
+        ret.setRequestStatus(requestStatus);
+
+        ret.setCertRequestType(request.getExtDataInString("cert_request_type"));
+
+        Path certRequestPath = CertRequestResource.class.getAnnotation(Path.class);
+        RequestId rid = request.getRequestId();
+
+        UriBuilder reqBuilder = uriInfo.getBaseUriBuilder();
+        reqBuilder.path(certRequestPath.value() + "/" + rid);
+        ret.setRequestURL(reqBuilder.build().toString());
+
+        //Get cert info if issued.
+        String serialNoStr = null;
+
+        if ((requestType != null) && (requestStatus != null)) {
+            if (requestStatus.equals(REQ_COMPLETE)) {
+                X509CertImpl impl[] = new X509CertImpl[1];
+                impl[0] = request.getExtDataInCert(IEnrollProfile.REQUEST_ISSUED_CERT);
+
+                BigInteger serialNo;
+                if (impl[0] != null) {
+                    serialNo = impl[0].getSerialNumber();
+                    serialNoStr = serialNo.toString();
+                }
+            }
+
+        }
+
+        if (serialNoStr != null && !serialNoStr.equals("")) {
+            Path certPath = CertResource.class.getAnnotation(Path.class);
+            UriBuilder certBuilder = uriInfo.getBaseUriBuilder();
+            certBuilder.path(certPath.value() + "/" + serialNoStr);
+            ret.setCertURL(certBuilder.build().toString());
+        }
+        return ret;
+    }
+
+}
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestData.java b/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestData.java
index f2979ebced50bdbca53564cc075d15e5894f0d11..caff0261d253347ab863e8adddb7db2debb61c26 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestData.java
+++ b/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestData.java
@@ -24,8 +24,10 @@ package com.netscape.cms.servlet.request.model;
 import java.io.ByteArrayInputStream;
 import java.io.ByteArrayOutputStream;
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.Iterator;
 import java.util.List;
+import java.util.Map;
 
 import javax.ws.rs.core.MultivaluedMap;
 import javax.xml.bind.JAXBContext;
@@ -38,6 +40,7 @@ import javax.xml.bind.annotation.XmlElement;
 import javax.xml.bind.annotation.XmlRootElement;
 
 import com.netscape.cms.servlet.profile.model.ProfileInput;
+import com.netscape.cms.servlet.profile.model.ProfileOutput;
 
 /**
  * @author jmagne
@@ -50,6 +53,7 @@ public class EnrollmentRequestData {
 
     private static final String PROFILE_ID = "profileId";
     private static final String RENEWAL = "renewal";
+    private static final String SERIAL_NUM = "serial_num";
 
     @XmlElement
     protected String profileId;
@@ -57,18 +61,30 @@ public class EnrollmentRequestData {
     @XmlElement
     protected boolean isRenewal;
 
+    @XmlElement
+    protected String serialNum;   // used for one type of renewal
+
+    @XmlElement
+    protected String remoteHost;
+
+    @XmlElement
+    protected String remoteAddr;
+
     @XmlElement(name = "Input")
     protected List<ProfileInput> inputs = new ArrayList<ProfileInput>();
 
+    @XmlElement(name = "Output")
+    protected List<ProfileOutput> outputs = new ArrayList<ProfileOutput>();
+
     public EnrollmentRequestData() {
+        // required for jaxb
     }
 
     public EnrollmentRequestData(MultivaluedMap<String, String> form) {
         profileId = form.getFirst(PROFILE_ID);
         String renewalStr = form.getFirst(RENEWAL);
-
+        serialNum = form.getFirst(SERIAL_NUM);
         isRenewal = new Boolean(renewalStr);
-
     }
 
     /**
@@ -94,7 +110,22 @@ public class EnrollmentRequestData {
         return isRenewal;
     }
 
-    public ProfileInput addInput(String name) {
+    public void addInput(ProfileInput input) {
+        ProfileInput curInput = getInput(input.getInputId());
+        if (curInput != null) {
+            getInputs().remove(curInput);
+        }
+        getInputs().add(input);
+    }
+
+    public void deleteInput(ProfileInput input) {
+        ProfileInput curInput = getInput(input.getInputId());
+        if (curInput != null) {
+            getInputs().remove(curInput);
+        }
+    }
+
+    public ProfileInput createInput(String name) {
 
         ProfileInput oldInput = getInput(name);
 
@@ -104,7 +135,7 @@ public class EnrollmentRequestData {
         ProfileInput newInput = new ProfileInput();
         newInput.setInputId(name);
 
-        inputs.add(newInput);
+        getInputs().add(newInput);
 
         return newInput;
     }
@@ -113,14 +144,11 @@ public class EnrollmentRequestData {
 
         ProfileInput input = null;
 
-        Iterator<ProfileInput> it = inputs.iterator();
+        Iterator<ProfileInput> it = getInputs().iterator();
 
         ProfileInput curInput = null;
-        while (it.hasNext())
-
-        {
+        while (it.hasNext()) {
             curInput = it.next();
-
             if (curInput != null && curInput.getInputId().equals(name))
                 break;
         }
@@ -128,6 +156,35 @@ public class EnrollmentRequestData {
         return input;
     }
 
+    public void addOutput(ProfileOutput output) {
+        ProfileOutput curOutput = getOutput(output.getOutputId());
+        if (curOutput != null) {
+            getOutputs().remove(curOutput);
+        }
+        getOutputs().add(output);
+    }
+
+    public void deleteOutput(ProfileOutput output) {
+        ProfileOutput curOutput = getOutput(output.getOutputId());
+        if (curOutput != null) {
+            getInputs().remove(curOutput);
+        }
+    }
+
+    public ProfileOutput getOutput(String name) {
+        ProfileOutput output = null;
+        ProfileOutput curOutput = null;
+
+        Iterator<ProfileOutput> it = getOutputs().iterator();
+        while (it.hasNext()) {
+            curOutput = it.next();
+            if (curOutput != null && curOutput.getOutputId().equals(name))
+                break;
+        }
+
+        return output;
+    }
+
     /**
      * @param renewal the renewal to set
      */
@@ -135,6 +192,24 @@ public class EnrollmentRequestData {
         this.isRenewal = isRenewal;
     }
 
+    public HashMap<String, String> toParams() {
+        HashMap<String, String> ret = new HashMap<String, String>();
+        ret.put("isRenewal", Boolean.valueOf(isRenewal).toString());
+        if (profileId != null) ret.put(PROFILE_ID, profileId);
+        if (serialNum != null) ret.put(SERIAL_NUM, serialNum);
+        if (remoteHost != null) ret.put("remoteHost", remoteHost);
+        if (remoteAddr != null) ret.put("remoteAddr", remoteAddr);
+
+        for (ProfileInput input: inputs) {
+            Map<String, String> attrs = input.getAttributes();
+            for (Map.Entry<String, String> entry: attrs.entrySet()) {
+                ret.put(entry.getKey(), entry.getValue());
+            }
+        }
+
+        return ret;
+    }
+
     public static void main(String args[]) throws Exception {
         EnrollmentRequestData data = new EnrollmentRequestData();
         data.setProfileId("caUserCert");
@@ -142,13 +217,13 @@ public class EnrollmentRequestData {
 
         //Simulate a "caUserCert" Profile enrollment
 
-        ProfileInput certReq = data.addInput("KeyGenInput");
+        ProfileInput certReq = data.createInput("KeyGenInput");
         certReq.setInputAttr("cert_request_type", "crmf");
         certReq.setInputAttr(
                 "cert_request",
                 "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz");
 
-        ProfileInput subjectName = data.addInput("SubjectNameInput");
+        ProfileInput subjectName = data.createInput("SubjectNameInput");
         subjectName.setInputAttr("sn_uid", "jmagne");
         subjectName.setInputAttr("sn_e", "jmagne@redhat.com");
         subjectName.setInputAttr("sn_c", "US");
@@ -159,7 +234,7 @@ public class EnrollmentRequestData {
         subjectName.setInputAttr("sn_cn", "Common");
         subjectName.setInputAttr("sn_o", "RedHat");
 
-        ProfileInput submitter = data.addInput("SubmitterInfoInput");
+        ProfileInput submitter = data.createInput("SubmitterInfoInput");
         submitter.setInputAttr("requestor_name", "admin");
         submitter.setInputAttr("requestor_email", "admin@redhat.com");
         submitter.setInputAttr("requestor_phone", "650-555-5555");
@@ -199,4 +274,48 @@ public class EnrollmentRequestData {
         }
     }
 
+    public String getSerialNum() {
+        return serialNum;
+    }
+
+    public void setSerialNum(String serialNum) {
+        this.serialNum = serialNum;
+    }
+
+    public List<ProfileInput> getInputs() {
+        return inputs;
+    }
+
+    public void setInputs(List<ProfileInput> inputs) {
+        this.inputs = inputs;
+    }
+
+    public String getRemoteAddr() {
+        return remoteAddr;
+    }
+
+    public void setRemoteAddr(String remoteAddr) {
+        this.remoteAddr = remoteAddr;
+    }
+
+    public String getRemoteHost() {
+        return remoteHost;
+    }
+
+    public void setRemoteHost(String remoteHost) {
+        this.remoteHost = remoteHost;
+    }
+
+    public List<ProfileOutput> getOutputs() {
+        return outputs;
+    }
+
+    public void setOutputs(List<ProfileOutput> outputs) {
+        this.outputs = outputs;
+    }
+
+    public void setRenewal(boolean isRenewal) {
+        this.isRenewal = isRenewal;
+    }
+
 }
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestDataFactory.java b/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestDataFactory.java
new file mode 100644
index 0000000000000000000000000000000000000000..3a09b7608cb3c0b07c5f79c8628acd0fa549a201
--- /dev/null
+++ b/base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestDataFactory.java
@@ -0,0 +1,51 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
+package com.netscape.cms.servlet.request.model;
+
+import java.util.Enumeration;
+import java.util.Locale;
+
+import com.netscape.certsrv.base.IArgBlock;
+import com.netscape.certsrv.profile.EProfileException;
+import com.netscape.certsrv.profile.IProfile;
+import com.netscape.certsrv.profile.IProfileInput;
+import com.netscape.cms.servlet.common.CMSRequest;
+import com.netscape.cms.servlet.profile.model.ProfileInput;
+import com.netscape.cms.servlet.profile.model.ProfileInputFactory;
+
+public class EnrollmentRequestDataFactory {
+
+    public static EnrollmentRequestData create(CMSRequest cmsReq, IProfile profile, Locale locale)
+            throws EProfileException {
+        IArgBlock params = cmsReq.getHttpParams();
+
+        EnrollmentRequestData ret = new EnrollmentRequestData();
+        ret.setProfileId(profile.getId());
+
+        // populate profile inputs
+        Enumeration<String> inputIds = profile.getProfileInputIds();
+        while (inputIds.hasMoreElements()) {
+            IProfileInput input = profile.getProfileInput(inputIds.nextElement());
+            ProfileInput addInput = ProfileInputFactory.create(input, params, locale);
+            ret.addInput(addInput);
+        }
+
+        return ret;
+    }
+
+}
-- 
1.7.10.1

